Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78131)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78132)
@@ -24,4 +24,5 @@
 #include "QIRichTextLabel.h"
 #include "UIApplianceUnverifiedCertificateViewer.h"
+#include "UIMessageCenter.h"
 #include "UIWizardImportApp.h"
 #include "UIWizardImportAppPageBasic2.h"
@@ -30,4 +31,5 @@
 #include "CAppliance.h"
 #include "CCertificate.h"
+#include "CVirtualSystemDescriptionForm.h"
 
 
@@ -74,6 +76,4 @@
         if (m_pFormEditor)
         {
-            m_pFormEditor->hide();
-
             /* Add into layout: */
             pMainLayout->addWidget(m_pFormEditor);
@@ -139,57 +139,69 @@
 void UIWizardImportAppPageBasic2::initializePage()
 {
-    /* Acquire appliance: */
-    CAppliance *pAppliance = m_pApplianceWidget->appliance();
-
-    /* Check if pAppliance is alive. If not just return here.
-     * This prevents crashes when an invalid ova file is supllied: */
-    if (!pAppliance)
-    {
-        if (wizard())
-            wizard()->reject();
-        return;
-    }
-
-    /* Acquire certificate: */
-    CCertificate comCertificate = pAppliance->GetCertificate();
-    if (comCertificate.isNull())
-        m_enmCertText = kCertText_Unsigned;
+    /* Check whether there was cloud source selected: */
+    const bool fIsSourceCloudOne = field("isSourceCloudOne").toBool();
+
+    /* Update widget visibility: */
+    m_pFormEditor->setVisible(fIsSourceCloudOne);
+    m_pApplianceWidget->setVisible(!fIsSourceCloudOne);
+
+    if (fIsSourceCloudOne)
+        m_pFormEditor->setVirtualSystemDescriptionForm(field("vsdForm").value<CVirtualSystemDescriptionForm>());
     else
     {
-        /* Pick a 'signed-by' name: */
-        m_strSignedBy = comCertificate.GetFriendlyName();
-
-        /* If trusted, just select the right message: */
-        if (comCertificate.GetTrusted())
-        {
-            if (comCertificate.GetSelfSigned())
-                m_enmCertText = !comCertificate.GetExpired() ? kCertText_SelfSignedTrusted : kCertText_SelfSignedExpired;
+        /* Acquire appliance: */
+        CAppliance *pAppliance = m_pApplianceWidget->appliance();
+
+        /* Check if pAppliance is alive. If not just return here.
+         * This prevents crashes when an invalid ova file is supllied: */
+        if (!pAppliance)
+        {
+            if (wizard())
+                wizard()->reject();
+            return;
+        }
+
+        /* Acquire certificate: */
+        CCertificate comCertificate = pAppliance->GetCertificate();
+        if (comCertificate.isNull())
+            m_enmCertText = kCertText_Unsigned;
+        else
+        {
+            /* Pick a 'signed-by' name: */
+            m_strSignedBy = comCertificate.GetFriendlyName();
+
+            /* If trusted, just select the right message: */
+            if (comCertificate.GetTrusted())
+            {
+                if (comCertificate.GetSelfSigned())
+                    m_enmCertText = !comCertificate.GetExpired() ? kCertText_SelfSignedTrusted : kCertText_SelfSignedExpired;
+                else
+                    m_enmCertText = !comCertificate.GetExpired() ? kCertText_IssuedTrusted     : kCertText_IssuedExpired;
+            }
             else
-                m_enmCertText = !comCertificate.GetExpired() ? kCertText_IssuedTrusted     : kCertText_IssuedExpired;
-        }
-        else
-        {
-            /* Not trusted!  Must ask the user whether to continue in this case: */
-            m_enmCertText = comCertificate.GetSelfSigned() ? kCertText_SelfSignedUnverified : kCertText_IssuedUnverified;
-
-            /* Translate page early: */
-            retranslateUi();
-
-            /* Instantiate the dialog: */
-            QPointer<UIApplianceUnverifiedCertificateViewer> pDialog = new UIApplianceUnverifiedCertificateViewer(this, comCertificate);
-            AssertPtrReturnVoid(pDialog.data());
-
-            /* Show viewer in modal mode: */
-            const int iResultCode = pDialog->exec();
-
-            /* Leave if viewer destroyed prematurely: */
-            if (!pDialog)
-                return;
-            /* Delete viewer finally: */
-            delete pDialog;
-
-            /* Dismiss the entire import-appliance wizard if user rejects certificate: */
-            if (iResultCode == QDialog::Rejected)
-                wizard()->reject();
+            {
+                /* Not trusted!  Must ask the user whether to continue in this case: */
+                m_enmCertText = comCertificate.GetSelfSigned() ? kCertText_SelfSignedUnverified : kCertText_IssuedUnverified;
+
+                /* Translate page early: */
+                retranslateUi();
+
+                /* Instantiate the dialog: */
+                QPointer<UIApplianceUnverifiedCertificateViewer> pDialog = new UIApplianceUnverifiedCertificateViewer(this, comCertificate);
+                AssertPtrReturnVoid(pDialog.data());
+
+                /* Show viewer in modal mode: */
+                const int iResultCode = pDialog->exec();
+
+                /* Leave if viewer destroyed prematurely: */
+                if (!pDialog)
+                    return;
+                /* Delete viewer finally: */
+                delete pDialog;
+
+                /* Dismiss the entire import-appliance wizard if user rejects certificate: */
+                if (iResultCode == QDialog::Rejected)
+                    wizard()->reject();
+            }
         }
     }