Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78274)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 78275)
@@ -19,4 +19,5 @@
 #include <QLabel>
 #include <QPointer>
+#include <QStackedLayout>
 #include <QVBoxLayout>
 
@@ -39,4 +40,5 @@
 
 UIWizardImportAppPage2::UIWizardImportAppPage2()
+    : m_pSettingsCntLayout(0)
 {
 }
@@ -47,4 +49,13 @@
     if (comForm.isNotNull())
         m_pFormEditor->setVirtualSystemDescriptionForm(comForm);
+}
+
+void UIWizardImportAppPage2::updatePageAppearance()
+{
+    /* Check whether there was cloud source selected: */
+    const bool fIsSourceCloudOne = fieldImp("isSourceCloudOne").toBool();
+
+    /* Update page appearance according to chosen source: */
+    m_pSettingsCntLayout->setCurrentIndex((int)fIsSourceCloudOne);
 }
 
@@ -69,28 +80,67 @@
         }
 
-        /* Create appliance widget: */
-        m_pApplianceWidget = new UIApplianceImportEditorWidget(this);
+        /* Create settings container layout: */
+        m_pSettingsCntLayout = new QStackedLayout;
+        if (m_pSettingsCntLayout)
         {
-            m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
-            m_pApplianceWidget->setFile(strFileName);
+            /* Create appliance widget container: */
+            QWidget *pApplianceWidgetCnt = new QWidget(this);
+            if (pApplianceWidgetCnt)
+            {
+                /* Create appliance widget layout: */
+                QVBoxLayout *pApplianceWidgetLayout = new QVBoxLayout(pApplianceWidgetCnt);
+                if (pApplianceWidgetLayout)
+                {
+                    pApplianceWidgetLayout->setContentsMargins(0, 0, 0, 0);
+
+                    /* Create appliance widget: */
+                    m_pApplianceWidget = new UIApplianceImportEditorWidget(pApplianceWidgetCnt);
+                    if (m_pApplianceWidget)
+                    {
+                        m_pApplianceWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::MinimumExpanding);
+                        m_pApplianceWidget->setFile(strFileName);
+
+                        /* Add into layout: */
+                        pApplianceWidgetLayout->addWidget(m_pApplianceWidget);
+                    }
+
+                    /* Create certificate label: */
+                    m_pCertLabel = new QLabel(QString(), pApplianceWidgetCnt);
+                    if (m_pCertLabel)
+                    {
+                        /* Add into layout: */
+                        pApplianceWidgetLayout->addWidget(m_pCertLabel);
+                    }
+                }
+
+                /* Add into layout: */
+                m_pSettingsCntLayout->addWidget(pApplianceWidgetCnt);
+            }
+
+            /* Create form editor container: */
+            QWidget *pFormEditorCnt = new QWidget(this);
+            if (pFormEditorCnt)
+            {
+                /* Create form editor layout: */
+                QVBoxLayout *pFormEditorLayout = new QVBoxLayout(pFormEditorCnt);
+                if (pFormEditorLayout)
+                {
+                    pFormEditorLayout->setContentsMargins(0, 0, 0, 0);
+
+                    /* Create form editor widget: */
+                    m_pFormEditor = new UIFormEditorWidget(pFormEditorCnt);
+                    if (m_pFormEditor)
+                    {
+                        /* Add into layout: */
+                        pFormEditorLayout->addWidget(m_pFormEditor);
+                    }
+                }
+
+                /* Add into layout: */
+                m_pSettingsCntLayout->addWidget(pFormEditorCnt);
+            }
 
             /* Add into layout: */
-            pMainLayout->addWidget(m_pApplianceWidget);
-        }
-
-        /* Create form editor widget: */
-        m_pFormEditor = new UIFormEditorWidget(this);
-        if (m_pFormEditor)
-        {
-            /* Add into layout: */
-            pMainLayout->addWidget(m_pFormEditor);
-        }
-
-        /* Create certificate label: */
-        m_pCertLabel = new QLabel("<cert label>", this);
-        if (m_pCertLabel)
-        {
-            /* Add into layout: */
-            pMainLayout->addWidget(m_pCertLabel);
+            pMainLayout->addLayout(m_pSettingsCntLayout);
         }
     }
@@ -107,16 +157,6 @@
     setTitle(UIWizardImportApp::tr("Appliance settings"));
 
-    /* Translate the description label: */
-    const bool fIsSourceCloudOne = field("isSourceCloudOne").toBool();
-    if (fIsSourceCloudOne)
-        m_pLabel->setText(UIWizardImportApp::tr("These are the the suggested settings of the cloud VM import "
-                                                "procedure, they are influencing the resulting local VM instance. "
-                                                "You can change many of the properties shown by double-clicking "
-                                                "on the items and disable others using the check boxes below."));
-    else
-        m_pLabel->setText(UIWizardImportApp::tr("These are the virtual machines contained in the appliance "
-                                                "and the suggested settings of the imported VirtualBox machines. "
-                                                "You can change many of the properties shown by double-clicking "
-                                                "on the items and disable others using the check boxes below."));
+    /* Update page appearance: */
+    updatePageAppearance();
 
     /* Translate the certificate label: */
@@ -155,11 +195,9 @@
 void UIWizardImportAppPageBasic2::initializePage()
 {
+    /* Update widget visibility: */
+    updatePageAppearance();
+
     /* Check whether there was cloud source selected: */
     const bool fIsSourceCloudOne = field("isSourceCloudOne").toBool();
-
-    /* Update widget visibility: */
-    m_pFormEditor->setVisible(fIsSourceCloudOne);
-    m_pApplianceWidget->setVisible(!fIsSourceCloudOne);
-    m_pCertLabel->setVisible(!fIsSourceCloudOne);
 
     if (fIsSourceCloudOne)
@@ -260,2 +298,27 @@
     return fResult;
 }
+
+void UIWizardImportAppPageBasic2::updatePageAppearance()
+{
+    /* Call to base-class: */
+    UIWizardImportAppPage2::updatePageAppearance();
+
+    /* Check whether there was cloud source selected: */
+    const bool fIsSourceCloudOne = field("isSourceCloudOne").toBool();
+    if (fIsSourceCloudOne)
+    {
+        m_pLabel->setText(UIWizardImportApp::tr("These are the the suggested settings of the cloud VM import "
+                                                "procedure, they are influencing the resulting local VM instance. "
+                                                "You can change many of the properties shown by double-clicking "
+                                                "on the items and disable others using the check boxes below."));
+        m_pFormEditor->setFocus();
+    }
+    else
+    {
+        m_pLabel->setText(UIWizardImportApp::tr("These are the virtual machines contained in the appliance "
+                                                "and the suggested settings of the imported VirtualBox machines. "
+                                                "You can change many of the properties shown by double-clicking "
+                                                "on the items and disable others using the check boxes below."));
+        m_pApplianceWidget->setFocus();
+    }
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78274)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 78275)
@@ -29,4 +29,5 @@
 /* Forward declarations: */
 class QLabel;
+class QStackedLayout;
 class QIRichTextLabel;
 
@@ -42,6 +43,12 @@
     void populateFormPropertiesTable();
 
+    /** Updates page appearance. */
+    virtual void updatePageAppearance();
+
     /** Returns appliance widget instance. */
     ImportAppliancePointer applianceWidget() const { return m_pApplianceWidget; }
+
+    /** Holds the settings container layout instance. */
+    QStackedLayout *m_pSettingsCntLayout;
 
     /** Holds the appliance widget instance. */
@@ -82,4 +89,7 @@
     virtual bool validatePage() /* override */;
 
+    /** Updates page appearance. */
+    virtual void updatePageAppearance() /* override */;
+
 private:
 